/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.JenisProdukDto;
import com.portofolio.service.JenisProdukService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/jenisProduk")
public class JenisProdukController extends LocaleController {
    @Lazy
	@Autowired
    private JenisProdukService jenisProdukService;
    
    
    @ApiOperation("Api Untuk Menyimpan JenisProduk")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody JenisProdukDto entity,HttpServletRequest request) {
        Map<String, Object> result = jenisProdukService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update JenisProduk")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdJenisProduk", required = true) Integer kdJenisProduk,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody JenisProdukDto entity, HttpServletRequest request) {
        Map<String, Object> result = jenisProdukService.update(entity,kdJenisProduk,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus JenisProduk Berdasarkan KdJenisProduk")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdJenisProduk", required = true) Integer kdJenisProduk,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = jenisProdukService.deleteById(kdJenisProduk, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua JenisProduk")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaJenisProduk") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaJenisProduk", required = false) String namaJenisProduk,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = jenisProdukService.grid(page, rows, sort, dir, namaJenisProduk,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan JenisProduk Berdasarkan kdJenisProduk")
    @GetMapping("/findByKdJenisProduk")
    public ResponseEntity<Map<String, Object>> findByKdJenisProduk(
    		@RequestParam(value = "kdJenisProduk", required = true) Integer kdJenisProduk, 
    		HttpServletRequest request) {
        Map<String, Object> result = jenisProdukService.findByKdJenisProduk(kdJenisProduk);
        return RestUtil.getJsonResponse(result);
    }


}
